# JSDoc: Class: TextStim

# Class: TextStim

## visual.TextStim(options)

#### new TextStim(options)

##### Parameters:

Name | Type | Description
--- | --- | ---

`options`

Object

###### Properties

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`name` | String |  |  | the name used when logging messages from this stimulus
`win` | module:core.Window |  |  | the associated Window
`text` | string | <optional> | "Hello World" | the text to be rendered
`font` | string | <optional> | "Arial" | the font family
`pos` | Array.<number> | <optional> | [0, 0] | the position of the center of the text
`color` | Color | <optional> | 'white' | the background color
`opacity` | number | <optional> | 1.0 | the opacity
`depth` | number | <optional> | 0 | the depth (i.e. the z order)
`contrast` | number | <optional> | 1.0 | the contrast
`units` | string | <optional> | "norm" | the units of the text size and position
`ori` | number |  |  | the orientation (in degrees)
`height` | number | <optional> | 0.1 | the height of the text
`bold` | boolean | <optional> | false | whether or not the text is bold
`italic` | boolean | <optional> | false | whether or not the text is italic
`alignHoriz` | string | <optional> | 'center' | horizontal alignment
`alignVert` | string | <optional> | 'center' | vertical alignment
`wrapWidth` | boolean |  |  | whether or not to wrap the text horizontally
`flipHoriz` | boolean | <optional> | false | whether or not to flip the text horizontally
`flipVert` | boolean | <optional> | false | whether or not to flip the text vertically
`clipMask` | PIXI.Graphics | <optional> | null | the clip mask
`autoDraw` | boolean | <optional> | false | whether or not the stimulus should be automatically drawn on every frame flip
`autoLog` | boolean | <optional> | false | whether or not to log

Mixes In:
  - ColorMixin
Source:
  - visual/TextStim.js, line 17
To Do:
  - vertical alignment, and orientation are currently NOT implemented

### Extends

- VisualStim

### Members

#### (protected) _getDefaultLetterHeight

Get the default letter height given the stimulus' units.

Source:
  - visual/TextStim.js, line 208

#### (protected) _getDefaultWrapWidth

Get the default wrap width given the stimulus' units.

Source:
  - visual/TextStim.js, line 231

#### getTextMetrics

Get the metrics estimated for the text and style. Note: getTextMetrics does not require the PIXI representation of the stimulus to be instantiated, unlike getSize().

Source:
  - visual/TextStim.js, line 176

#### setColor

Setter for the color attribute.

Source:
  - visual/TextStim.js, line 371

### Methods

#### (protected) _estimateBoundingBox()

Estimate the bounding box.

Source:
  - visual/TextStim.js, line 320

#### (protected) getBoundingBox(tightopt) → {Array.<number>}

Get the bounding gox.

##### Parameters:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`tight` | boolean | <optional> | false | whether or not to fit as closely as possible to the text

Source:
  - visual/TextStim.js, line 254

##### Returns:

- the bounding box, in the units of this TextStim

Type
  Array.<number>